
/* asu bloadmake ver 1.1 */
/* (C) Masaki Oba 2017 */
/*  2-Clause BSD License. */
/* compile
   check only bcc32
   Windows Borland(#define WINDOWS)(Convert to SJIS)
      bcc32 -DWINDOWS ihex2bin.c ihex.c

   no check
   UNIX cc(#define UNIX)
      cc -o ihex2bin -DMACOSX ihex2bin.c ihex.c

   no check
   UNIX gcc(#define UNIX)
      gcc -o ihex2bin ihex.c

   no check
   Windows Microsoft(#define WINDOWS)(Convert to SJIS)
      cl -DWINDOWS ihex2bin.c ihex.c

   no check
   Mac OS X XCode(#define MACOSX)(OS no namae igai wa UNIX to onaji)
      cc -o ihex2bin -DMACOSX ihex2bin.c ihex.c

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>

/*
#ifdef MSDOSREAL
#include <io.h>
#endif
*/

#ifdef MACOSX
#define OS "Mac OS X"
#endif

#ifdef WINDOWS
#include <io.h>
#define MSDOSSS
#define OS "Windows"
#endif

#ifndef WINDOWS
#ifndef MSDOSREAL
#ifndef MACOSX
#define OS "UNIX"
#include <unistd.h>
#endif
#endif
#endif

#define  VERSION "1.1"
#define  NENGOU  "2017"


#define  ERROR -1

char mem[33000];

int Orgflag,Runflag,Sizeflag,Jumpflag,Kakuflag;
int Bdscf;	/* write jump initial code for BDS C with fixed C.CCC */
long Orgad = (long)-1;
long Runad = (long)-1;
long Rsize = (long)-1;
long Jumpad = (long)-1;
char Kakuchousi[100];


#ifdef ROMA_ONLY
#undef ROMAJI
#define ROMAJI
#endif

#ifdef ROMAJI
int Alpf = 1;	/* 0:kanji mode  1:roma ji mode */
#else
int Alpf = 0;	/* 0:kanji mode  1:roma ji mode */
#endif

void eprintf(char *str)
{
  fprintf(stderr,str);
  fprintf(stderr,"\n%c",7);
}

void eprintf2(char *str,char *str2)
{
  fprintf(stderr,str,str2);
  fprintf(stderr,"\n%c",7);
}

void setumei(void) 
{
  /* setumei hyouji */
if(!Alpf){
/*KANJI*/ printf("MSXbloadwb_tvOłB\n");
/*KANJI*/ printf("ftHgORGƎsԒn8100HAǂݍ݃TCY̓t@CTCYB\n");
/*KANJI*/ printf("ftHgo̓t@ĆA̓t@C̊gqBINɕς́B\n\n");
/*KANJI*/ printf("g: bloadmake [-bAN] [-o<16i>] [-s<16i>] [-r<16i>] [-j<16i>] [-k<o͊gq>] [Ǎt@C [݃t@C]\n");
/*KANJI*/ printf("   xxx-o,-s,-r,-jł16iB-kł͊gq̕B\n");
/*KANJI*/ printf("     -b  BDS CMSX-BASICΉC.CCCp̏[`ɃWvR[h𖄂ߍށB\n");
/*KANJI*/ printf("        WvAhXύXꂽA-r ܂-j IvVgĂB\n");
/*KANJI*/ printf("     -oxxx  ǂݍ݊JnԒn(ORG)BႦ -o8A00 Ȃ 8A00HԒnɓǂݍށB\n");
/*KANJI*/ printf("     -sxxx  ǂݍ݃TCYBႦ -sffb Ȃ FFBHoCgǂݍށB\n");
/*KANJI*/ printf("     -rxxx  sJnԒnBႦ -r9b00 Ȃ 9B00HԒnsB\n");
/*KANJI*/ printf("     -jxxx  vO擪3oCgɃWv߂\"JP xxxx\"㏑ŖߍށB\n");
/*KANJI*/ printf("     -kxxx  o̓t@C̊gqwB-kABC Ȃ gq.ABCɂ\n");
#ifdef ROMAJI
/*KANJI*/ printf("     -A  G[̃bZ[W[}ŏo͂B(ftHg)\n");
/*KANJI*/ printf("     -N  G[̃bZ[WSpŏo͂B\n");
#else
/*KANJI*/ printf("     -A  G[̃bZ[W[}ŏo͂B\n");
/*KANJI*/ printf("     -N  G[̃bZ[WSpŏo͂B(ftHg)\n");
#endif
}
else{
printf("add MSX bload header\n");
printf("Default: ORG 8100H , Load size=file size , Run adress 8100H\n");
printf("Default output file name: \"xxxxx.XXX\"(input name) to \"xxxxx.bin\"\n\n");
printf("Usage: bloadmake [-bAN] [-o<hex>] [-s<hex>] [-r<hex>] [-j<hex>] [-k<extension>] readfile [writefile]\n");
printf("   xxx -o,-s,-r,-j hex numbers. -k filename extension.\n");
printf("     -b write jump to initial code for BDS C with MSX-BASIC fixed C.CCC\n");
printf("         if jump address changed then use -r or -j option.\n");
printf("     -oxxx  ORG address(hex).  for example -o8A00\n");
printf("     -sxxx  load byte size(hex).  for example -sffb\n");
printf("     -rxxx  run address(hex).  for example -r9b00\n");
printf("     -jxxx  wirte jump code \"JP xxxxH\" 3bytes in ORG to ORG+2\n");
printf("     -kxxx  output filename extension.  for example -kABC\n");
#ifdef ROMAJI
printf("     -A  romanized character message(default)\n");
#ifndef ROMA_ONLY
printf("     -N  Japanese message\n");
#endif
#else
printf("     -A  romanized character message\n");
printf("     -N  Japanese message(default)\n");
#endif
}
printf("\n     asu bloadmake ver ");
printf(VERSION);
printf(" for %s",OS);
printf(" (C) Masaki Oba ");
printf(NENGOU);
printf("\n");
  putchar(7);
}

unsigned xtou(char *str)
{
  /* 16sinsuu mojiretu -> unsigned */
  unsigned s;
  char c;
  s=0;
  while(*str !=0){
    if(('a'-1)< *str && *str < ('f'+1))
      c= (*str & 0x9f)+9;
    else if(('A'-1)< *str && *str <('F'+1))
      c= (*str & 0xbf)+9;
    else if(('0'-1)< *str && *str <('9'+1))
      c=*str & 0x0f;
    else 
      c=0;
    s=s*16+c;
    ++str;
  }
  return s;
}

int iseigo(unsigned char ccc)
{
  /* eiji? */
  if((ccc>64 && ccc<91) || (ccc>96 && ccc<123)) return 0; else return -1;
}

int option(short argc,char **argv)
{
  int i;
  int tugia;
  int lof;	/* arg option flag */

  /* getopt() not use */
  for(i=1;i<argc;++i){
    tugia = 0;
    lof = 0;
    if(argv[i][tugia]=='-'){
     while(1){
       switch (argv[i][tugia+1]){
         case 'b':
           Bdscf = 1;
           break;
         case 'j':
           if(Jumpflag){
             if(Alpf){
               fprintf(stderr,"Error: duplicate '-%c' option\n",argv[i][tugia+1]);
             }
             else{
/*KANJI*/      fprintf(stderr,"G[: -%c IvVdB\n",argv[i][tugia+1]);
             }
             return -1;
           }
           if(!argv[i][tugia+2]){
             ++i;
             if(i>=argc-1){
               Jumpad=0;
             }
             else{
               if(argv[i][0]!='-')
                 Jumpad=xtou(&argv[i][0]);
               else{
                 Jumpad = 0;
                 --i;
               }
             }
           }
           else{
             Jumpad=xtou(&argv[i][tugia+2]);
           }
           lof = 1;	/* arg option flag */
           Jumpflag=1;
           break;
         case 'o':
           if(Orgflag){
             if(Alpf){
               fprintf(stderr,"Error: duplicate '-%c' option\n",argv[i][tugia+1]);
             }
             else{
/*KANJI*/      fprintf(stderr,"G[: -%c IvVdB\n",argv[i][tugia+1]);
             }
             return -1;
           }
           if(!argv[i][tugia+2]){
             ++i;
             if(i>=argc-1){
               Orgad=0;
             }
             else{
               if(argv[i][0]!='-')
                 Orgad=xtou(&argv[i][0]);
               else{
                 Orgad = 0;
                 --i;
               }
             }
           }
           else{
             Orgad=xtou(&argv[i][tugia+2]);
           }
           lof = 1;	/* arg option flag */
           Orgflag=1;
           break;
         case 'r':
           if(Runflag){
             if(Alpf){
               fprintf(stderr,"Error: duplicate '-%c' option\n",argv[i][tugia+1]);
             }
             else{
/*KANJI*/      fprintf(stderr,"G[: -%c IvVdB\n",argv[i][tugia+1]);
             }
             return -1;
           }
           if(!argv[i][tugia+2]){
             ++i;
             if(i>=argc-1){
               Runad=0;
             }
             else{
               if(argv[i][0]!='-')
                 Runad=xtou(&argv[i][0]);
               else{
                 Runad = 0;
                 --i;
               }
             }
           }
           else{
             Runad=xtou(&argv[i][tugia+2]);
           }
           lof = 1;	/* arg option flag */
           Runflag=1;
           break;
         case 'k':
           if(Kakuflag){
             if(Alpf){
               fprintf(stderr,"Error: duplicate '-%c' option\n",argv[i][tugia+1]);
             }
             else{
/*KANJI*/      fprintf(stderr,"G[: -%c IvVdB\n",argv[i][tugia+1]);
             }
             return -1;
           }
           if(!argv[i][tugia+2]){
             ++i;
             if(i>=argc-1){
             }
             else{
               if(argv[i][0]!='-'){
                 strcpy(Kakuchousi,&argv[i][0]);
               }
               else{
                 --i;
               }
             }
           }
           else{
             strcpy(Kakuchousi,&argv[i][tugia+2]);
           }
           Kakuflag = 1;
           lof = 1;	/* arg option flag */
           break;
         case 'A':
           Alpf = 1;	/* roma ji mode */
           break;
         case 's':
           if(Sizeflag){
             if(Alpf){
               fprintf(stderr,"Error: duplicate '-%c' option\n",argv[i][tugia+1]);
             }
             else{
/*KANJI*/      fprintf(stderr,"G[: -%c IvVdB\n",argv[i][tugia+1]);
             }
             return -1;
           }
           if(!argv[i][tugia+2]){
             ++i;
             if(i>=argc-1){
               Rsize=0;
             }
             else{
               if(argv[i][0]!='-')
                 Rsize=xtou(&argv[i][0]);
               else{
                 Rsize = 0;
                 --i;
               }
             }
           }
           else{
             Rsize=xtou(&argv[i][tugia+2]);
           }
           lof = 1;
           Sizeflag=1;
           break;
         case 'N':
#ifndef ROMA_ONLY
           Alpf = 0;
#endif
           break;
  
         default:
           if(Alpf){
             fprintf(stderr,"Error: Invalid option '-%c'\n",argv[i][tugia+1]);
           }
           else{
/*KANJI*/    fprintf(stderr,"G[: ݂ȂIvVłB'-%c'\n",argv[i][tugia+1]);
           }
           return -1;
      }
       if(lof){
         break;
       }
       else
       if(iseigo(argv[i][tugia+2]))
         break;
       else
         ++tugia;
     }
    }
  }
  return 0;
}

int changeoutname(char *fname)
{
  int len,i,ka;
  len = strlen(fname);

  if(len <= 0){
    return -1;
  }

  for(i=len-1;i>=0;--i){
    if(fname[i] == '.'){
      fname[i] = 0;
      break;
    }
    if(fname[i] == '/' || fname[i] == '\\'){
      break;
    }
  }

  if(Kakuchousi[0]){
    if(Kakuchousi[0] != '.'){
      strcat(fname,".");
    }
    strcat(fname,Kakuchousi);
  }
  else{
    strcat(fname,".bin");
  }
  return 0;
}

int main(int argc,char **argv)
{
  int i;
  long fsize;
  int fnc;
  int wsize;
  char *inpname;
  char *outname;
  char outnbuf[1000];
  unsigned char bheader[10]; /* MSX bload header */
  int fd;
  unsigned short temp;
  unsigned short z_jump_ad = 0x87f6;	/* jmp initial adress for BDS C with MSX-BASIC fixed C.CCC */
  unsigned short z_org_ad = 0x8100;
  unsigned short z_run_ad = 0x8100;
  unsigned short z_r_size;

  Orgflag = 0;
  Sizeflag = 0;
  Runflag = 0;
  Jumpflag = 0;
  Kakuflag = 0;
  Kakuchousi[0] = 0;
  outname = outnbuf;
  outname[0] = 0;

  if(argc<2){
    setumei();
    return 1;
  }

  if(option(argc,argv)){
    setumei();
    return -1;
  }

  fnc = 0;
  for(i=1;i<argc;++i){
    if(argv[i][0] != '-'){
      ++fnc;
      if(fnc == 1){
        inpname = argv[i];
      }
      else
      if(fnc == 2){
        outname = argv[i];
      }
      else{
        setumei();
        return -1;
      }
    }
  }

  if(fnc == 0){
    if(Alpf){
      fprintf(stderr,"please input filename\n\n");
    }
    else{
/*KANJI*/ fprintf(stderr,"t@C͂ĂB\n\n");
    }
    setumei();
    return -1;
  }

  if(fnc > 2){
    setumei();
    return -1;
  }

  if(Orgflag){
    if(Orgad >= 0xffff){
      if(Alpf){
        eprintf("-o wrong. org adress > 0xFFFF.");
      }
      else{
/*KANJI*/          eprintf("-o ORGwl0xFFFF傫B");
      }
      return -1;
    } 
    z_org_ad = Orgad;
  }

  if(Runflag){
    if(Runad < (long)0){
      if(Alpf){
        eprintf("-r wrong. run adress < 0.");
      }
      else{
/*KANJI*/          eprintf("-r ̎sԒnwl0菬B");
      }
      return -1;
    } 
    if(Runad >= (long)0xffff){
      if(Alpf){
        eprintf("-r wrong. run adress > 0xFFFF.");
      }
      else{
/*KANJI*/          eprintf("-r ̎sԒnwl0xFFFF傫B");
      }
      return -1;
    } 
    z_run_ad = Runad;
  }

  if(Sizeflag){
    if(Rsize < (long)0){
      if(Alpf){
        eprintf("-s wrong. load size < 0.");
      }
      else{
/*KANJI*/          eprintf("-s ̓ǂݍ݃TCYwl0菬B");
      }
      return -1;
    } 
    if(Rsize >= 0xffff){
      if(Alpf){
        eprintf("-s wrong. load size > 0xFFFF.");
      }
      else{
/*KANJI*/          eprintf("-s ̓ǂݍ݃TCYwl0xFFFF傫B");
      }
      return -1;
    } 
    z_r_size = Rsize;
  }

  if(outname[0]){
    if(Kakuchousi[0]){
      changeoutname(outname);
    }
  }
  else{
    strcpy(outname,inpname);
    changeoutname(outname);
  }

#ifdef WINDOWS
  if(-1 == (fd = open(inpname,O_RDONLY | O_BINARY,S_IREAD))){
#else
  if(-1 == (fd = open(inpname,O_RDONLY,S_IREAD))){
#endif
#if 0
    } /* for vi editor % command */
#endif
    if(Alpf){
      fprintf(stderr,"Error: file cannot open[%s]\n",inpname);
    }
    else{
/*KANJI*/      fprintf(stderr,"G[: t@CJ܂B[%s]\n",inpname);
    }
    return -1;
  }

  if((fsize = lseek(fd,0,SEEK_END)) == -1){
    if(Alpf){
      fprintf(stderr,"Error: file seek error[%s]\n",inpname);
    }
    else{
/*KANJI*/      fprintf(stderr,"G[: t@CEV[NsB[%s]\n",inpname);
    }
    close(fd);
    return -1;
  }

  if(lseek(fd,0,SEEK_SET) == -1){
    if(Alpf){
      fprintf(stderr,"Error: file seek error[%s]\n",inpname);
    }
    else{
/*KANJI*/      fprintf(stderr,"G[: t@CEV[NsB[%s]\n",inpname);
    }
    close(fd);
    return -1;
  }
  if(fsize > 31000){
    if(Alpf){
      fprintf(stderr,"Error: file size too big.[%s]\n",inpname);
    }
    else{
/*KANJI*/      fprintf(stderr,"G[: t@CTCY傫B[%s]\n",inpname);
    }
    close(fd);
    return -1;
  }
  if(fsize != read(fd,mem,fsize)){
    if(Alpf){
      printf("Error: can't read data.%d bytes[%s] \n",fsize,inpname);
    }
    else{
/*KANJI*/      fprintf(stderr,"G[: %doCg̃f[^ǂݍ߂܂B[%s]\n",fsize,inpname);
    }
    close(fd);
    return 8;
  }
  close(fd);

#ifdef WINDOWS
  if(-1 == (fd = open(outname,O_WRONLY | O_CREAT | O_TRUNC | O_BINARY,S_IREAD|S_IWRITE))){
#else
  if(-1 == (fd = open(outname,O_WRONLY | O_CREAT | O_TRUNC,S_IREAD|S_IWRITE))){
#endif
#if 0
    } /* for vi editor % command */
#endif

    if(Alpf){
      fprintf(stderr,"ERROR: file cannot open[%s]\n",outname);
    }
    else{
/*KANJI*/      fprintf(stderr,"G[:t@CJ܂B[%s]\n",outname);
    }
    return -1;
  }

  fprintf(stderr,"\tasu bloadmake   ver");

  fprintf(stderr,VERSION);
  fprintf(stderr,"   for %s",OS);
  fprintf(stderr,"\n\t\t\t(C) Masaki Oba  ");
  fprintf(stderr,NENGOU);
  fprintf(stderr,"\n");

  /* bload header 7byte */
  bheader[0] = 0xfe;

  temp = z_org_ad;
  bheader[1] = (unsigned char)(temp & 0xff);
  temp >>= 8;  
  bheader[2] = (unsigned char)temp;

  if(Sizeflag == 0){
    z_r_size = fsize;  
  }
  temp = z_r_size;
  bheader[3] = (unsigned char)(temp & 0xff);
  temp >>= 8;  
  bheader[4] = (unsigned char)temp;

  temp = z_run_ad;
  bheader[5] = (unsigned char)(temp & 0xff);
  temp >>= 8;  
  bheader[6] = (unsigned char)temp;

  printf("ORG=%xH , Load byte size=%xH  ,Run address=%xH \n",z_org_ad, z_r_size, z_run_ad);

  if(7 != write(fd,bheader,7)){
    if(Alpf){
      fprintf(stderr,"Error: can't write bload header[%s] \n",outname);
    }
    else{
/*KANJI*/ fprintf(stderr,"G[: bloadwb_̏ݎsB[%s] \n",outname);
    }
    close(fd);
    return 8;
  }

  if(Jumpflag){
    mem[0] = (char)0xc3;	/* Z80 "JP" */
    z_jump_ad = Jumpad; 
    temp = z_jump_ad;
    mem[1] = (char)temp & 0xff;
    temp >>= 8;
    mem[2] = (char)temp;
    printf("write jump(JP) %xH code 3bytes in ORG to ORG+2\n",z_jump_ad);
  }
  else
  if(Bdscf){
    printf("write jump initial address[%xH] for BDS C+MSX-BASIC fixed C.CCC\n",z_jump_ad);
    mem[0] = (char)0xc3;	/* Z80 "JP" */
    temp = z_jump_ad;
    mem[1] = (char)temp & 0xff;
    temp >>= 8;
    mem[2] = (char)temp;
    mem[3] = 0;
  }

  if(fsize != write(fd,mem,fsize)){
    if(Alpf){
      fprintf(stderr,"Error: can't write program data[%s] \n",outname);
    }
    else{
/*KANJI*/ fprintf(stderr,"G[: vOf[^̏ݎsB[%s] \n",outname);
    }
    close(fd);
    return 8;
  }


  close(fd);

  if(chmod(outname,S_IREAD|S_IWRITE) != 0){
    printf("Error: Unable to change file mode(read and write).\n");
  }

  printf("output [%s]\n",outname);

  return 0;
}

